Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections
Interface MultiMap

All Superinterfaces:
  java.util.Map

All Known Implementing Classes:
  MultiHashMap, MultiValueMap

    public interface MultiMap

extends java.util.Map

Defines a map that holds a collection of values against each key.

A `MultiMap` is a Map with slightly different semantics. Putting a value into the map will add the value to a Collection at that key. Getting a value will return a Collection, holding all the values put to that key.

For example:

     MultiMap mhm = new MultiHashMap();
     mhm.put(key, "A");
     mhm.put(key, "B");
     mhm.put(key, "C");
     Collection coll = (Collection) mhm.get(key);

`coll` will be a collection containing "A", "B", "C".

NOTE: Additional methods were added to this interface in Commons Collections 3.1. These were added solely for documentation purposes and do not change the interface as they were defined in the superinterface `Map` anyway.

Since:
  Commons Collections 2.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Christopher Berry, James Strachan, Stephen Colebourne

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Method Summary
`boolean` | `containsValue(java.lang.Object value)` Checks whether the map contains the value specified.
`java.lang.Object` | `get(java.lang.Object key)` Gets the collection of values associated with the specified key.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Adds the value to the collection associated with the specified key.
`java.lang.Object` | `remove(java.lang.Object key)` Removes all values associated with the specified key.
`java.lang.Object` | `remove(java.lang.Object key, java.lang.Object item)` Removes a specific value from map.
`int` | `size()` Gets the number of keys in this map.
`java.util.Collection` | `values()` Gets a collection containing all the values in the map.

Methods inherited from interface java.util.Map
`clear, containsKey, entrySet, equals, hashCode, isEmpty, keySet, putAll`

Method Detail

### remove

    java.lang.Object remove(java.lang.Object key,
                            java.lang.Object item)

  Removes a specific value from map.

  The item is removed from the collection mapped to the specified key. Other values attached to that key are unaffected.

  If the last value for a key is removed, implementations typically return `null` from a subsequant `get(Object)`, however they may choose to return an empty collection.

  Parameters:
    `key` - the key to remove from
    `item` - the item to remove
  Returns:
    the value removed (which was passed in), null if nothing removed
  Throws:
    `java.lang.UnsupportedOperationException` - if the map is unmodifiable
    `java.lang.ClassCastException` - if the key or value is of an invalid type
    `java.lang.NullPointerException` - if the key or value is null and null is invalid

### size

    int size()

  Gets the number of keys in this map.

  Implementations typically return only the count of keys in the map This cannot be mandated due to backwards compatability of this interface.

  Specified by:
    `size` in interface `java.util.Map`
  Returns:
    the number of key-collection mappings in this map

### get

    java.lang.Object get(java.lang.Object key)

  Gets the collection of values associated with the specified key.

  The returned value will implement `Collection`. Implementations are free to declare that they return `Collection` subclasses such as `List` or `Set`.

  Implementations typically return `null` if no values have been mapped to the key, however the implementation may choose to return an empty collection.

  Implementations may choose to return a clone of the internal collection.

  Specified by:
    `get` in interface `java.util.Map`
  Parameters:
    `key` - the key to retrieve
  Returns:
    the `Collection` of values, implementations should return `null` for no mapping, but may return an empty collection
  Throws:
    `java.lang.ClassCastException` - if the key is of an invalid type
    `java.lang.NullPointerException` - if the key is null and null keys are invalid

### containsValue

    boolean containsValue(java.lang.Object value)

  Checks whether the map contains the value specified.

  Implementations typically check all collections against all keys for the value. This cannot be mandated due to backwards compatability of this interface.

  Specified by:
    `containsValue` in interface `java.util.Map`
  Parameters:
    `value` - the value to search for
  Returns:
    true if the map contains the value
  Throws:
    `java.lang.ClassCastException` - if the value is of an invalid type
    `java.lang.NullPointerException` - if the value is null and null value are invalid

### put

    java.lang.Object put(java.lang.Object key,
                         java.lang.Object value)

  Adds the value to the collection associated with the specified key.

  Unlike a normal `Map` the previous value is not replaced. Instead the new value is added to the collection stored against the key. The collection may be a `List`, `Set` or other collection dependent on implementation.

  Specified by:
    `put` in interface `java.util.Map`
  Parameters:
    `key` - the key to store against
    `value` - the value to add to the collection at the key
  Returns:
    typically the value added if the map changed and null if the map did not change
  Throws:
    `java.lang.UnsupportedOperationException` - if the map is unmodifiable
    `java.lang.ClassCastException` - if the key or value is of an invalid type
    `java.lang.NullPointerException` - if the key or value is null and null is invalid
    `java.lang.IllegalArgumentException` - if the key or value is invalid

### remove

    java.lang.Object remove(java.lang.Object key)

  Removes all values associated with the specified key.

  Implementations typically return `null` from a subsequant `get(Object)`, however they may choose to return an empty collection.

  Specified by:
    `remove` in interface `java.util.Map`
  Parameters:
    `key` - the key to remove values from
  Returns:
    the `Collection` of values removed, implementations should return `null` for no mapping found, but may return an empty collection
  Throws:
    `java.lang.UnsupportedOperationException` - if the map is unmodifiable
    `java.lang.ClassCastException` - if the key is of an invalid type
    `java.lang.NullPointerException` - if the key is null and null keys are invalid

### values

    java.util.Collection values()

  Gets a collection containing all the values in the map.

  Inplementations typically return a collection containing the combination of values from all keys. This cannot be mandated due to backwards compatability of this interface.

  Specified by:
    `values` in interface `java.util.Map`
  Returns:
    a collection view of the values contained in this map

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.